<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/28/2003 *
 * ===============                              Last change: 06/10/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-del_user.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Delete members                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder loeschen                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Display only title when no form was submitted
ADD_DESCR('admin', __FILE__);

// User exists..
if ((isFormSent()) || ((REQUEST_ISSET_POST('del')) && (REQUEST_ISSET_POST(('reason'))))) {
	// Delete users account
	$result_user = SQL_QUERY_ESC("SELECT userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
	array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
	if (SQL_NUMROWS($result_user) == 1) {
		// Free memory
		SQL_FREERESULT($result_user);

		// Delete user account
		deleteUserAccount(REQUEST_GET('uid'), REQUEST_POST('reason'));

		// Output message
		LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_DEL_COMPLETED'));
	} else {
		// Account does not exists!
		LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"admin_failed\">".sprintf(getMessage('ADMIN_MEMBER_404'), REQUEST_GET('uid'))."</div>");
	}
} elseif (REQUEST_ISSET_POST(('no'))) {
	// Do not delete him...
	redirectToUrl(ADMIN_CREATE_USERID_LINK(REQUEST_GET('uid')));
} elseif (!REQUEST_ISSET_GET('uid')) {
	// Output selection form with all confirmed user accounts listed
	ADD_MEMBER_SELECTION_BOX();
} else {
	// Realy want to delete?
	$result = SQL_QUERY_ESC("SELECT email, surname, family FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
	array(bigintval(REQUEST_GET('uid'))), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == 1) {
		// Load data
		list ($email, $sname, $fname) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Prepare content
		$content = array(
			'email'   => generateMemberEmailLink($email, "user_data"),
			'surname' => $sname,
			'family'  => $fname,
			'header'  => sprintf(getMessage('ADMIN_HEADER_DEL_ACCOUNT'), REQUEST_GET('uid')),
			'text'    => sprintf(getMessage('ADMIN_TEXT_DEL_ACCOUNT'), REQUEST_GET('uid')),
			'userid'  => REQUEST_GET('uid')
		);

		// Display form
		LOAD_TEMPLATE("admin_del_user", false, $content);
	} else {
		// Account does not exists!
		LOAD_TEMPLATE('admin_settings_saved', false, "<div class=\"admin_failed\">".sprintf(getMessage('ADMIN_MEMBER_404'), REQUEST_GET('uid'))."</div>");
	}
}

//
?>
